AI_A2A_CAP_ZONE = {
    ClassName ="AI_A2A_CAP_ZONE"
}

function AI_A2A_CAP_ZONE:New(Detection, AICAPZone)
    local self = BASE:Inherit(self, AI_A2A_DISPATCHER:New(Detection))
    self.Detection = Detection

    self:AddTransition("*", "Started", "*")
    self:AddTransition("*", "CAPZone", "*")
    self:AddTransition("*", "Stop", "*")

    self:SetAICAPZone(AICAPZone)

    self:__Start(5)
    return self
end

function AI_A2A_CAP_ZONE:SetAICAPZone(AICAPZone)
    self:F2({ AICAPZone })
    self.AICAPZone = AICAPZone
end

function AI_A2A_CAP_ZONE:SchedulerCAP(SquadronName)
    if self.AICAPZone == true then
        self:CAPZone(SquadronName)
    else
        self:CAP(SquadronName)
    end
end

function AI_A2A_CAP_ZONE:onafterCAPZone(From, Event, To, SquadronName)
    self:F({SquadronName = SquadronName})
    self.DefenderSquadrons[SquadronName] = self.DefenderSquadrons[SquadronName] or {} 
    self.DefenderSquadrons[SquadronName].Cap = self.DefenderSquadrons[SquadronName].Cap or {}

    local DefenderSquadron = self:CanCAP( SquadronName )

    if DefenderSquadron then
        local Cap = DefenderSquadron.Cap

        if Cap then
            local DefenderCAP, DefenderGrouping = self:ResourceActivate( DefenderSquadron )
            if DefenderCAP then
                local Fsm = AI_AIR_CAP_ZONE:New(DefenderCAP, Cap.Zone, Cap.PatrolFloorAltitude, Cap.PatrolCeilingAltitude, Cap.PatrolMinSpeed, Cap.PatrolMaxSpeed, Cap.AltType)
                --local Fsm = AI_AIR_CAP_ZONE:New(DefenderCAP, Cap.Zone, Cap.FloorAltitude, Cap.CeilingAltitude, Cap.PatrolMinSpeed, Cap.PatrolMaxSpeed, Cap.AltType)
                Fsm:SetDispatcher(self)
                Fsm:SetHomeAirbase(DefenderSquadron.Airbase)
                Fsm:SetFuelThreshold(DefenderSquadron.FuelThreshold or self.DefenderDefault.FuelThreshold, 60)
                Fsm:SetDamageThreshold(self.DefenderDefault.DamageThreshold)
                Fsm:SetDisengageRadius( self.DisengageRadius )
                Fsm:SetDetectionOn()
                Fsm:SetRefreshTimeInterval(10)
                Fsm:SetControllable(DefenderCAP)
                Fsm:__Start(3)

                function CheckState(Fsm, AIGroup)
                    BASE:E("State of AI_AIR_CAP_ZONE " .. AIGroup:GetName() .. " is " .. Fsm:GetState())
                end
            
                SCHEDULER:New(nil, CheckState, {Fsm, DefenderCAP}, 5, 10)

                self:SetDefenderTask(SquadronName, DefenderCAP, "CAP", Fsm)

                function Fsm:OnAfterStart(AIGroup, From, Event, To)
                    Fsm:HandleEvent(EVENTS.PilotDead)
                    Fsm:HandleEvent(EVENTS.Ejection)
                    Fsm:HandleEvent(EVENTS.Crash)
                end

                function Fsm:onafterRTB(DefenderGroup, From, Event, To)
                    self:F({"CAP RTB", DefenderGroup:GetName()})

                    self:GetParent(self).onafterRTB( self, DefenderGroup, From, Event, To )

                    local DefenderName = DefenderGroup:GetCallsign()
                    local Dispatcher = self:GetDispatcher() -- #AI_A2A_DISPATCHER
                    local Squadron = Dispatcher:GetSquadronFromDefender( DefenderGroup )
                    Dispatcher:ClearDefenderTaskTarget( Defender )
                end

                function Fsm:onafterHome(Defender, From, Event, To, Action)
                    BASE:E(Defender:GetName() .. " Inside Fsm:onafterHome")
                    self:F({"CAP Home", Defender:GetName()})
                    self:GetParent(self).onafterHome( self, AIGroup, From, Event, To )
                    
                    local Dispatcher = self:GetDispatcher() -- #AI_A2A_DISPATCHER
                    local Squadron = Dispatcher:GetSquadronFromDefender( Defender )

                    if Action and Action == "Destroy" then
                        Dispatcher:RemoveDefenderFromSquadron( Squadron, Defender )
                        Defender:Destroy()
                    end
                      
                    if Dispatcher:GetSquadronLanding( Squadron.Name ) == AI_A2A_DISPATCHER.Landing.NearAirbase then
                        Dispatcher:RemoveDefenderFromSquadron( Squadron, Defender )
                        Defender:Destroy()
                    end
                end

                function Fsm:OnEventPilotDead(EventData)
                    if Fsm.DetectedUnits and Fsm.DetectedUnits[EventData.iniUnit] then
                        Fsm:__Destroy(1, EventData)
                    end
                end

                function Fsm:OnEventEjection(EventData)
                    if Fsm.DetectedUnits and Fsm.DetectedUnits[EventData.iniUnit] then
                        Fsm:__Destroy(1, EventData)
                    end
                end

                function Fsm:OnEventCrash(EventData)
                    if Fsm.DetectedUnits and Fsm.DetectedUnits[EventData.iniUnit] then
                        Fsm:__Destroy(1, EventData)
                    end
                end
            end
        end
    end
end