-------------------------
--  DESPACHADORES  A2A --
-------------------------
--//-- ↓↓↓ inicio del despachador aliado ↓↓↓ --//--
---
local Blue_CC = COMMANDCENTER:New( GROUP:FindByName( "BLUE BASE GRP"), "HQ_Blue" )
local Red_CC = COMMANDCENTER:New( GROUP:FindByName( "RED BASE GRP"), "HQ_Red" )

RedDetectionSetGroup = SET_GROUP:New():FilterPrefixes({ "☢" }):FilterCoalitions(coalition.side.BLUE):FilterStart()
BlueDetectionSetGroup = SET_GROUP:New():FilterPrefixes({ "☮" }):FilterCoalitions(coalition.side.Red):FilterStart()

Red_DetectionArea = DETECTION_AREAS:New( RedDetectionSetGroup, 30000)
Red_DetectionArea:Start()

Blue_DetectionArea = DETECTION_AREAS:New(BlueDetectionSetGroup, 30000)
Blue_DetectionArea:Start()

local zone = ZONE:New("Combat_Zone")
local AICAPZone = true

BlueA2ADispatcher = AI_A2A_CAP_ZONE:New(Blue_DetectionArea, AICAPZone)
BlueA2ADispatcher:SetDefaultGrouping( 1 )
BlueA2ADispatcher:SetDefaultFuelThreshold(0.25)
BlueA2ADispatcher:SetDefaultDamageThreshold(1)
BlueA2ADispatcher:SetDefaultTakeoffInAir()
BlueA2ADispatcher:SetDefaultTakeoffInAirAltitude(1550)
BlueA2ADispatcher:SetDefaultLandingNearAirbase()

BlueA2ADispatcher:SetSquadron("BlueSqn001", "BLUE SPAWN POINT", { "☮ F5E3_Blue", "☮ Mig21_Blue", "☮ M2K_Blue", "☮ MiG29_Blue", "☮ Su27_Blue", "☮ Su33_Blue", "☮ F16_Blue", "☮ F15_Blue", "☮ F14_Blue" } )
BlueA2ADispatcher:SetSquadronFuelThreshold("BlueSqn001", 0.25)
BlueA2ADispatcher:SetSquadronCap( "BlueSqn001", zone, 4000, 10000, 500, 1200, 800, 900 )
BlueA2ADispatcher:SetSquadronCapInterval( "BlueSqn001", 1, 60, 120 )

BlueA2ADispatcher:SetSquadron("BlueSqn002", "BLUE SPAWN POINT", { "☮ F5E3_Blue", "☮ Mig21_Blue", "☮ M2K_Blue", "☮ MiG29_Blue", "☮ Su27_Blue", "☮ Su33_Blue", "☮ F16_Blue", "☮ F15_Blue", "☮ F14_Blue" } )
BlueA2ADispatcher:SetSquadronFuelThreshold("BlueSqn002", 0.25)
BlueA2ADispatcher:SetSquadronCap( "BlueSqn002", zone, 4000, 10000, 500, 1200, 800, 900 )
BlueA2ADispatcher:SetSquadronCapInterval( "BlueSqn002", 1, 60, 120 )
BlueA2ADispatcher:SetSquadronTakeoffInAir("BlueSqn002", 1050)


A2ADispatcher = AI_A2A_CAP_ZONE:New(Red_DetectionArea, AICAPZone)
A2ADispatcher:SetDefaultGrouping( 1 )
A2ADispatcher:SetDefaultFuelThreshold(0.25)
A2ADispatcher:SetDefaultDamageThreshold(1)
A2ADispatcher:SetDefaultTakeoffInAir()
A2ADispatcher:SetDefaultTakeoffInAirAltitude(1550)
A2ADispatcher:SetDefaultLandingNearAirbase()

A2ADispatcher:SetSquadron("RedSqn001", "RED SPAWN POINT", { "☢ F5E3_Red", "☢ Mig21_Red", "☢ M2K_Red", "☢ MiG29_Red", "☢ Su27_Red", "☢ Su33_Red", "☢ F16_Red", "☢ F15_Red", "☢ F14_Red" } )
A2ADispatcher:SetSquadronFuelThreshold("RedSqn001", 0.25)
A2ADispatcher:SetSquadronCap( "RedSqn001", zone, 4000, 10000, 500, 1200, 800, 900 )
A2ADispatcher:SetSquadronCapInterval( "RedSqn001", 1, 60, 120 )

A2ADispatcher:SetSquadron("RedSqn002", "RED SPAWN POINT", { "☢ F5E3_Red", "☢ Mig21_Red", "☢ M2K_Red", "☢ MiG29_Red", "☢ Su27_Red", "☢ Su33_Red", "☢ F16_Red", "☢ F15_Red", "☢ F14_Red" } )
A2ADispatcher:SetSquadronFuelThreshold("RedSqn002", 0.25)
A2ADispatcher:SetSquadronCap( "RedSqn002", zone, 4000, 10000, 500, 1200, 800, 900 )
A2ADispatcher:SetSquadronCapInterval( "RedSqn002", 1, 60, 120 )

--//-- ↑↑↑ fin del despachador enemigo ↑↑↑ --//--

--[[ --- Lista de aerodromos - Caucaso
AIRBASE.Caucasus.Gelendzhik
AIRBASE.Caucasus.Krasnodar_Pashkovsky
AIRBASE.Caucasus.Sukhumi_Babushara
AIRBASE.Caucasus.Gudauta
AIRBASE.Caucasus.Batumi
AIRBASE.Caucasus.Senaki_Kolkhi
AIRBASE.Caucasus.Kobuleti
AIRBASE.Caucasus.Kutaisi
AIRBASE.Caucasus.Tbilisi_Lochini
AIRBASE.Caucasus.Soganlug
AIRBASE.Caucasus.Vaziani
AIRBASE.Caucasus.Anapa_Vityazevo
AIRBASE.Caucasus.Krasnodar_Center
AIRBASE.Caucasus.Novorossiysk
AIRBASE.Caucasus.Krymsk
AIRBASE.Caucasus.Maykop_Khanskaya
AIRBASE.Caucasus.Sochi_Adler
AIRBASE.Caucasus.Mineralnye_Vody
AIRBASE.Caucasus.Nalchik
AIRBASE.Caucasus.Mozdok
AIRBASE.Caucasus.Beslan
 --]]---
--------------------------------------------------------------------------------------------------------------------------------------------------------------------
--FIN---------------------------------------------------------------------------------------------------------------------------------------------------------------
SCHEDULER:New( nil, 
    function()
		PlayZone = ZONE:New( "Play_Zone" )
		PlayZone:SmokeZone( SMOKECOLOR.Red, 350 )
		trigger.action.outText("Combat zone limits activated! Don't cross those borders pilot!", 10)
end, {}, 15, 300)


trigger.action.outText("☑☑ ALL SYSTEMS OK ☑☑", 10)